﻿Imports ThinkGeo.MapSuite.DesktopEdition
Imports ThinkGeo.MapSuite.Core
Public Class Form1
   Private Const NAD_83_16N As Integer = 26916
   Private Const USA_Albers As Integer = 102003
   Private msPolyPath As String = "..\..\Data\SmallPoly.shp"
   Private msRoadPath As String = "..\..\Data\Road.shp"


   Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
      Dim oOverlay As New LayerOverlay
      Dim oShapeFile As ShapeFileFeatureLayer
      Dim oExtent As RectangleShape

      oShapeFile = New ShapeFileFeatureLayer(msPolyPath)
      oShapeFile.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1)
      oShapeFile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      oOverlay.Layers.Add("Poly", oShapeFile)
      oShapeFile.Open()
      oExtent = oShapeFile.GetBoundingBox

      oShapeFile = New ShapeFileFeatureLayer(msRoadPath)
      oShapeFile.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Red, 3, False)
      oShapeFile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      oOverlay.Layers.Add("Road", oShapeFile)

      moMap.MinimumScale = 1
      moMap.MapUnit = GeographyUnit.Meter
      moMap.ZoomLevelSnapping = ZoomLevelSnappingMode.SnapUp

      Dim oZoomLevels As New ZoomLevelSet
      For Each oZoomLevel In oZoomLevels.GetZoomLevels()
         moMap.ZoomLevelSet.CustomZoomLevels.Add(oZoomLevel)
      Next oZoomLevel


      moMap.Overlays.Add("LayerOverlay", oOverlay)
      moMap.CurrentExtent = oExtent

      moMap.Refresh()
      MessageBox.Show("There are now " & moMap.ZoomLevelSet.CustomZoomLevels.Count & " custom zoom levels.")

   End Sub

   Private Sub moMap_CurrentScaleChanged(sender As Object, e As ThinkGeo.MapSuite.DesktopEdition.CurrentScaleChangedWinformsMapEventArgs) Handles moMap.CurrentScaleChanged
      Dim oMap As WinformsMap = TryCast(sender, WinformsMap)
      If Not oMap Is Nothing Then
         With oMap
            If Me.ToolStrip1.Items.Count > 0 Then
               Me.ToolStrip1.Items("Scale").Text = "Scale: " & String.Format("{0:#,###.00} ft / in", .CurrentScale / 12)
            End If
         End With
      End If
   End Sub


   Private Sub btnChangeUnit_Click(sender As System.Object, e As System.EventArgs) Handles btnChangeUnit.Click
      moMap.MapUnit = GeographyUnit.Meter

      MessageBox.Show("There are now " & moMap.ZoomLevelSet.CustomZoomLevels.Count & " custom zoom levels.")

   End Sub
End Class
